/*******************************************************************************
*  Statistics.cpp - how many of what?
*
*  Berzerk/
*
*  Part of the BuckoSoft Network Monitor
*  Copyright 2011 - BuckoSoft, Inc.
*
\*******************************************************************************/

#include "stdafx.h"
#include "../config.h"

#include <string>
#include <iostream>
#include <stdio.h>

#include "Statistics.h"

namespace berzerk {
namespace statistics {
const char crlf[] = { '\r', '\n', 0};


///////////////////////////////////////////////////////////////////////////////
Statistics::Statistics() {
	this->linesRead = 0;
	this->ipsKilled = 0;
}

///////////////////////////////////////////////////////////////////////////////
void Statistics::incKilled(const string& ip, const string& rule, const string& deathLine) {
	this->myMutex.lock();
	ipsKilled++;
	StatLine* sl = new StatLine(ip, rule, deathLine);
	set<string>::iterator iter;
	if ((iter = ipsKilledSet.find(ip)) == ipsKilledSet.end()) {
		ipsKilledSet.insert(ip);
		statLines.push_front(sl);
		if (statLines.size() > 20) {
			sl = statLines.back();
			statLines.pop_back();
			ipsKilledSet.erase(sl->ip);
			delete sl;
		}
	}
	this->myMutex.unlock();
}

///////////////////////////////////////////////////////////////////////////////
string	StatLine::toXML() {
	string s;
	s += "<statline>";
	s += crlf;
	s += "<ip>";
	s += this->ip;
	s += "</ip>";
	s += crlf;
	s += "<rule>";
	s += this->rule;
	s += "</rule>";
	s += crlf;
	s += "<deathLine>";
	s += this->deathLine;
	s += "</deathLine>";
	s += crlf;
	s += "<date>";
	s += this->getTime();
	s += "</date>";
	s += "</statline>";
	s += crlf;
	return(s);

}

///////////////////////////////////////////////////////////////////////////////
string StatLine::getTime() {
	struct tm       *tmp;
	static char     month_names[13][4] = {
			"Jan", "Feb", "Mar", "Apr", "May", "Jun",
			"Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
			"Bug"
	};
	static char     buf[80];

	tmp = localtime(&this->sldate);
	sprintf(buf, "%02d %s %02d:%02d:%02d ",
			tmp->tm_mday, month_names[tmp->tm_mon],
			tmp->tm_hour, tmp->tm_min, tmp->tm_sec);
	return buf;
}


}	// namespace statistics
}	// namespace berzerk
